﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.Windows.Tools.Controls;
using System.Threading;
using Microsoft.International.Converters.PinYinConverter;

namespace WpfAutoComplete
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        bool restoreCustomSource = true;
        List<string> customSource;
        int publicI = 0;
        public MainWindow()
        {
            InitializeComponent();

            AutoComplete1.CustomSource = new string[]
            {
 "拗阿扒堡暴辟","红霉素","阿莫西林", "ha哈", "purple","盘尼西林", "四环素", "环丙沙星", "黄连上清", "蓝芩口服液",
"舒筋搓洗液", "双黄连口服液", "甲硝唑", "111", "magenta", "maroon", "navy",
"olive", "orange", "pink", "red", "tan", "teal",
"violet", "wheat", "white", "yellow","李惠媛","李汇源","李晓羽","李晓转","蜻蜓","睢冰","线博"
            };

            AutoComplete1.TextChanged += AutoComplete1_TextChanged;
            customSource = new List<string>();
            AutoComplete1.Items.Filter = ItemFilter;
            restoreCustomSource = false;
        }



        private void AutoComplete1_TextChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {


            textBox.Text = AutoComplete1.Text + "\n";

            //publicI = 0;
            AutoComplete1.Items.Filter = ItemFilter;


            foreach (var item in AutoComplete1.ItemContainerGenerator.Items)
            {
                textBox.Text += item.ToString() + "\n";
            }

        }
        //public bool ItemFilter(object item)
        //{

        //    string tbText="";
        //    if (restoreCustomSource)
        //    {
        //        tbText = (string)item + GetPinYin((string)item);
        //        AutoComplete1.AddToSelectedObjects((string)item);
        //        customSource.Add(tbText);
        //        return true;
        //    }
        //    if (customSource[publicI].ToUpper().Contains(AutoComplete1.Text.ToUpper()))
        //    {
        //        AutoComplete1.AddToSelectedObjects(customSource[publicI]);//add 2016/6/10 it will display in popup
        //        publicI++;
        //        return true;//return true mean display in popup
        //    }
        //    publicI++;
        //    return false;

        //}


        public bool ItemFilter(object item)
        {
                // compare itself with input                                    //compare PinYin
            if(((string)item).ToUpper().Contains(AutoComplete1.Text.ToUpper())|| CompareMultiPinYin(GetPinYin(AutoComplete1.Text),GetMultiPinYin((string)item)))
           
            {
                AutoComplete1.AddToSelectedObjects((string)item);//add 2016/6/10 it will display in popup
                return true;//return true mean display in popup
            }
            return false;

        }

        public bool CompareMultiPinYin(string one, string libs)
        {
            string[] total = libs.Split(new char[] { '\n' }, StringSplitOptions.RemoveEmptyEntries);//

            int num = 1;
            foreach (var item in total)
            {
                num *= item.Length;
            }
            string[] comparelibs = new string[num];//multi Pinyin result
            for (int i = 0; i < total.Length; i++)
            {
                for (int j = 0; j < comparelibs.Length;)
                {
                    for (int k = 0; k < total[i].Length; k++)
                    {
                        comparelibs[j] += total[i].Substring(k,1);
                        j++;
                    }
                }
            }
            for (int i = 0; i < comparelibs.Length; i++)
            {
                if (comparelibs[i].Contains(one))//multi Pinyin result
                    return true;
            }
            return false;
        }
        public string GetMultiPinYin(string s)
        {
            char[] hanzi = s.ToCharArray();
            StringBuilder r = new StringBuilder(10);

            foreach (char c in hanzi)
            {
                if (c >= 33 && c <= 126)
                {
                    r.Append(c.ToString().ToUpper() + "\n");
                    continue;
                }
                ChineseChar chineseChar = new ChineseChar(c);

                //因为一个汉字可能有多个读音，pinyins是一个集合
                var pinyins = chineseChar.Pinyins;
                string temp = "";
                //下面的方法只是简单的获得了集合中第一个非空元素
                foreach (var pinyin in pinyins)
                {
                    if (pinyin != null)
                    {
                        //我这里只取首字母             //拼音的最后一个字符是音调
                        if (temp.Contains(pinyin.Substring(0, 1)))// pinyin.Length - 1);
                        {
                            continue;
                        }
                        else
                        {
                            temp += pinyin.Substring(0, 1);
                        }
                    }
                }
                r.Append(temp + "\n");
            }
            return r.ToString();
        }
        public string GetPinYin(string s)
        {
            char[] hanzi = s.ToCharArray();
            string r = "";

            foreach (char c in hanzi)
            {
                if (c< 0xB0A1)//第一个汉字 阿 //(c >= 33 && c <= 126)
                {
                    r += c.ToString().ToUpper();
                    continue;
                }
                ChineseChar chineseChar = new ChineseChar(c);

                //因为一个汉字可能有多个读音，pinyins是一个集合
                var pinyins = chineseChar.Pinyins;

                //下面的方法只是简单的获得了集合中第一个非空元素
                foreach (var pinyin in pinyins)
                {
                    if (pinyin != null)
                    {
                        r += pinyin.Substring(0, 1); //我这里只取首字母,如果是多音字，只获取一个
                        break;
                    }
                }
            }
            return r;
        }

    }
}
